using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Security.Cryptography;
using System.Text;
using System.IO;
using System.Collections.Generic;

[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class Service : System.Web.Services.WebService
{
    UnicodeEncoding ByteConverter = new UnicodeEncoding();
    RSACryptoServiceProvider RSA = new RSACryptoServiceProvider();
    byte[] SifreliVeri, dosya, safVeri;
    string privateKey;
    FileStream fs;

    [WebMethod]
    public bool KullaniciEkle(string kullanici, string password, string soru, string cevap)
    {
        if (File.Exists("c:\\xx\\" + kullanici + ".txt"))
            return false; // kullanc var.

        privateKey = RSA.ToXmlString(true);
        File.WriteAllText("c:\\xx\\" + kullanici + ".pri", privateKey);

        fs = File.Create("c:\\xx\\" + kullanici + ".txt");

        SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(password), false);
        fs.Write(SifreliVeri, 0, SifreliVeri.Length);
        SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(soru), false);
        fs.Write(SifreliVeri, 0, SifreliVeri.Length);
        SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(cevap), false);
        fs.Write(SifreliVeri, 0, SifreliVeri.Length);
        fs.Close();
        return true;
    }

    [WebMethod]
    public string GizliSoru(string kullanici)
    {
        dosya = new byte[300]; 
        if (!File.Exists("c:\\xx\\" + kullanici + ".txt"))
            return null; // kullanc yok.

        privateKey = File.ReadAllText("c:\\xx\\" + kullanici + ".pri");
        RSA.FromXmlString(privateKey);

        fs = File.OpenRead("c:\\xx\\" + kullanici + ".txt");
        fs.Read(dosya, 0, 256);
        Kopyala_128Byte(128, 256); // Gizli Soru
        safVeri = RSA.Decrypt(SifreliVeri, false);
        fs.Close();
        return ByteConverter.GetString(safVeri);
    }

    [WebMethod]
    public bool CevapDogruMu(string kullanici, string cevap)
    {
        dosya = new byte[400]; 
        if (!File.Exists("c:\\xx\\" + kullanici + ".txt"))
            return false; // kullanc yok.

        privateKey = File.ReadAllText("c:\\xx\\" + kullanici + ".pri");
        RSA.FromXmlString(privateKey);

        fs = File.OpenRead("c:\\xx\\" + kullanici + ".txt");
        fs.Read(dosya, 0, 384);
        Kopyala_128Byte(256, 384); // Cevap
        safVeri = RSA.Decrypt(SifreliVeri, false);
        fs.Close();
        return cevap == ByteConverter.GetString(safVeri);
    }
    [WebMethod]
    public bool KullaniciYenile(string kullanici, string yeniSifre, string cevap)
    {
        if (!CevapDogruMu(kullanici, cevap))
            return false;

        if (!File.Exists("c:\\xx\\" + kullanici + ".txt"))
            return false; // kullanc yok.

        privateKey = File.ReadAllText("c:\\xx\\" + kullanici + ".pri");
        RSA.FromXmlString(privateKey);

        fs = File.Open("c:\\xx\\" + kullanici + ".txt", FileMode.Open, FileAccess.ReadWrite);
        fs.Read(dosya, 0, 384);
        Kopyala_128Byte(256, 384); // Cevap
        safVeri = RSA.Decrypt(SifreliVeri, false);

        if(cevap != ByteConverter.GetString(safVeri))
            return false;

        fs.Seek(0, SeekOrigin.Begin);
        SifreliVeri = RSA.Encrypt(ByteConverter.GetBytes(yeniSifre), false);
        fs.Write(SifreliVeri, 0, SifreliVeri.Length);
        fs.Close();
        return true;
    }
    private void Kopyala_128Byte(int bas, int son)
    {
        SifreliVeri = new byte[128];
        for (int i = bas, j = 0; i < son; ++i, ++j)
            SifreliVeri[j] = dosya[i];
    }

    [WebMethod]
    public string[] AnaGruplariGetir(string kullanici, string sifre)
    {
        KullaniciHesabi hesap = new KullaniciHesabi();
        if (!hesap.HesabiOku(kullanici, sifre))
            return null;

        string[] anaGruplar = new string[hesap.grup.Count];
        for (int i = 0; i < hesap.grup.Count; ++i)
            anaGruplar[i] = hesap.grup[i].GrupAdi; 
        
        return anaGruplar;
    }

    [WebMethod]
    public string[] AltGruplariGetir(string kullanici, string sifre, int index)
    {
        KullaniciHesabi hesap = new KullaniciHesabi();
        if (!hesap.HesabiOku(kullanici, sifre))
            return null;
        if (index > hesap.grup.Count)
            return null;

        string[] altGruplar = new string[hesap.grup[index-1].Size];
        for (int i = 0; i < altGruplar.Length; ++i)
            altGruplar[i] = hesap.grup[index-1].getAltgrup(i).GrupAdi;

        return altGruplar;
    }

    [WebMethod]
    public string[] AltGrupOzellikleriGetir(string kullanici, string sifre, int i, int j)
    {
        KullaniciHesabi hesap = new KullaniciHesabi();
        AltGrup altGrup = new AltGrup();
        if (!hesap.HesabiOku(kullanici, sifre))
            return null;
        if (i > hesap.grup.Count)
            return null;

        string[] ozellik = new string[10];
        altGrup = hesap.grup[i-1].getAltgrup(j-1);
        ozellik[0] = altGrup.Sirket;
        ozellik[1] = altGrup.Ekbilgi;
        ozellik[2] = altGrup.Aciklama;
        ozellik[3] = altGrup.Tarih;
        ozellik[4] = altGrup.Sifre;
        ozellik[5] = altGrup.Sure.ToString();
        ozellik[6] = altGrup.MinKarakter.ToString();
        ozellik[7] = altGrup.MinRakam.ToString();
        ozellik[8] = altGrup.MinBuyuk.ToString();
        ozellik[9] = altGrup.BasKarakter.ToString();
        return ozellik;
    }

    [WebMethod]
    public bool AltGrupOzellikleriKaydet(string kullanici, string sifre, int i, int j, string[] ozellik)
    {
        KullaniciHesabi hesap = new KullaniciHesabi();
        if (!hesap.HesabiOku(kullanici, sifre))
            return false;
        if (i > hesap.grup.Count)
            return false;

        hesap.grup[i].getAltgrup(j).Sirket = ozellik[0];
        hesap.grup[i].getAltgrup(j).Ekbilgi = ozellik[1];
        hesap.grup[i].getAltgrup(j).Aciklama = ozellik[2];
        hesap.grup[i].getAltgrup(j).Tarih = ozellik[3];
        hesap.grup[i].getAltgrup(j).Sifre = ozellik[4];
        hesap.grup[i].getAltgrup(j).Sure = Convert.ToInt32(ozellik[5]);
        hesap.grup[i].getAltgrup(j).MinKarakter = Convert.ToInt32(ozellik[6]);
        hesap.grup[i].getAltgrup(j).MinRakam = Convert.ToInt32(ozellik[7]);
        hesap.grup[i].getAltgrup(j).MinBuyuk = Convert.ToInt32(ozellik[8]);
        hesap.grup[i].getAltgrup(j).BasKarakter = Convert.ToInt32(ozellik[9]);

        hesap.HesabiKaydet(kullanici, sifre);
        return true;
    }
    [WebMethod]
    public bool AnaGrupEkle(string kullanici, string sifre, string anaGrupadi)
    {
        KullaniciHesabi hesap = new KullaniciHesabi();
        AnaGrup temp = new AnaGrup();
        if (!hesap.HesabiOku(kullanici, sifre))
            return false;

        for (int i = 0; i < hesap.grup.Count; ++i)
            if (anaGrupadi == hesap.grup[i].GrupAdi)
                return false;

        temp.GrupAdi = anaGrupadi;
        hesap.grup.Add(temp);
        hesap.HesabiKaydet(kullanici, sifre);
        return true;
    }

    [WebMethod]
    public bool AltGrupEkle(string kullanici, string sifre, int index, string altGrupadi)
    {
        KullaniciHesabi hesap = new KullaniciHesabi();
        AltGrup temp = new AltGrup();
        if (!hesap.HesabiOku(kullanici, sifre))
            return false;
        if (index > hesap.grup.Count)
            return false;

        temp.GrupAdi = altGrupadi;
        hesap.grup[index].YeniEkle(temp);

        hesap.HesabiKaydet(kullanici, sifre);
        return true;
    }

    [WebMethod]
    public bool AnaGrupSil(string kullanici, string sifre, int index)
    {
        KullaniciHesabi hesap = new KullaniciHesabi();

        if (!hesap.HesabiOku(kullanici, sifre))
            return false;

        if (index > hesap.grup.Count)
            return false;

        hesap.grup.RemoveAt(index);
        hesap.HesabiKaydet(kullanici, sifre);
        return true;
    }

    [WebMethod]
    public bool AltGrupSil(string kullanici, string sifre, int i, int j)
    {
        KullaniciHesabi hesap = new KullaniciHesabi();

        if (!hesap.HesabiOku(kullanici, sifre))
            return false;
        if (i > hesap.grup.Count)
            return false;

        hesap.grup[i].Sil(j);
        hesap.HesabiKaydet(kullanici, sifre);
        return true;
    }
}
